

% find range of bit-rates and powers for each link
% if a bit-rate/power combination is not possible even with no interference, then this combination is not included.
% this includes bit-rates that are x0.5, x1 and x2 of those currently used and it included powers that are x0.5, x1 and x2 are are current used. This range could easily be increased

MIN_INTERFERENCE = 1e-20; % 200dB interference is the same as zero
MakeRealSch

%VMu = V*Mu;
%I = find(VMu >=max(VMu)-1e-2*max(VMu)); % fin
I = find(xx>0);
if (length(I)>size(V,2))
    disp('there are more active assignments than the number of links -  run remove redundancy')
end

clear BitRates
clear Powers
for k = 1:size(V,2)
    SU = S(I(find(S(I,k)>1e-4)),k);
    J = sort(unique(SU)); % list of powers used by this node
    BitRates{k} = [];
    Powers{k} =[];
    for j=1:length(J)
        for pi = 1:3
            if (pi==1), p = J(j); if ( min(abs(p-Powers{k}))/p < .1) continue; end; 
            elseif (pi==2), p=J(j)/2; if ( min(abs(p-Powers{k}))/p < .1) continue; end;
            elseif (pi==3 && J(j)<1), p = min(1,J(j)*2); if ( min(abs(p-Powers{k}))/p < .1) continue; end;
            end
            VU = V(I(find(V(I,k)>1e-12)),k);
            bb = sort(unique(VU));
            for i = 1:length(bb)
                
                if (bb(i)/2 <= VScale*log(1 + H(k,k)*p/(MIN_INTERFERENCE+NOISE)))
                    % is possible
                    II = find(Powers{k}==p); % bitrates with this power
                    if (isempty(BitRates{k}(II)) || min(abs( bb(i)/2 - BitRates{k}(II)))/(bb(i)/2) > .05) % check if this bit-rate is pretty much already in the list
                        BitRates{k} = [BitRates{k}, bb(i)/2];
                        Powers{k} = [Powers{k}, p];
                    end
                else
                    % br is not possible. try adding max br with this power
                    II = find(Powers{k}==p);
                    bt = VScale*log(1 + H(k,k)*p/(MIN_INTERFERENCE+NOISE));
                    if (isempty(BitRates{k}(II)) || min(abs(bt - BitRates{k}(II)))/bt > .05)
                        BitRates{k} = [BitRates{k}, VScale*log(1 + H(k,k)*p/(MIN_INTERFERENCE+NOISE))];
                        Powers{k} = [Powers{k}, p];
                    end
                    break;        % no other high bit-rates are possible                
                end
                
                if (bb(i) <= VScale*log(1 + H(k,k)*p/(MIN_INTERFERENCE+NOISE)))
                    II = find(Powers{k}==p); % bitrates with this power                    
                    if (isempty(BitRates{k}(II)) || min(abs( bb(i) - BitRates{k}(II)))/(bb(i)) > .05) % check if this bit-rate is pretty much already in the list
                        BitRates{k} = [BitRates{k}, bb(i)];
                        Powers{k} = [Powers{k}, p];
                    end
                else
                    II = find(Powers{k}==p);
                    bt = VScale*log(1 + H(k,k)*p/(MIN_INTERFERENCE+NOISE));
                    if (isempty(BitRates{k}(II)) || min(abs(bt - BitRates{k}(II)))/bt > .05 )
                        BitRates{k} = [BitRates{k}, VScale*log(1 + H(k,k)*p/(MIN_INTERFERENCE+NOISE))];
                        Powers{k} = [Powers{k}, p];
                    end
                    continue
                end
                
                if (bb(i)*2 <= VScale*log(1 + H(k,k)*p/(MIN_INTERFERENCE+NOISE)))
                    II = find(Powers{k}==p); % bitrates with this power
                    if (isempty(BitRates{k}(II)) || min(abs( bb(i)*2 - BitRates{k}(II)))/(2*bb(i)) > .05) % check if this bit-rate is pretty much already in the list
                        BitRates{k} = [BitRates{k}, bb(i)*2];
                        Powers{k} = [Powers{k}, p];
                    end
                else
                    II = find(Powers{k}==p);
                    bt = VScale*log(1 + H(k,k)*p/(MIN_INTERFERENCE+NOISE));
                    if (isempty(BitRates{k}(II)) || min(abs(bt - BitRates{k}(II)))/bt > .05)
                        BitRates{k} = [BitRates{k}, VScale*log(1 + H(k,k)*p/(MIN_INTERFERENCE+NOISE))];
                        Powers{k} = [Powers{k}, p];
                    end                    
                end
            end
        end
    end
end
    
    
    