function u = HessianUtil(p)
global HI
global NOISE
global MuI
global VScale
U = zeros(1,length(p));
W = zeros(1,length(p));
if (size(p,1)>size(p,2))
    p = p';
end
for i=1 : length(p)
    Wa = (p*HI(:,i) + NOISE);
    Wb = Wa - p(i)*HI(i,i);
    U(i) = MuI(i) * HI(i,i) / (Wa )^2;
    W(i) = MuI(i) * HI(i,i)*p(i)/Wa/Wb * (1/Wa + 1/Wb);
end
G = zeros(length(p));
E = zeros(length(p));
F = zeros(length(p));
for j = 1 : length(p)
    G(j,:) = HI(j,:) .* W;
    E(j,:) = HI(j,:).* (W.*diag(HI)');
    F(j,:) = HI(j,:) .* U;
end

u = -F - F' + HI*G' - E - E';
for i=1:length(p)
    u(i,i) = u(i,i) + F(i,i) + E(i,i);
end
u = -VScale*0.5*(u+u');