% clear BitRates  % BitRate{i} is the set of bit-rates that link i might transmit at
% for i=1:size(Links,1)
%     BitRates{i} = [1 2 4];  % the simple case where e3ach link transmits at 1 2 or 4 bps/hz
% end

FindRangeOfBitRatesWithPower

NotAllowed = []; % list of links that must be off for the current assignment (since no assignment has been made, this list is empty)
Set = [];   % the set of links that is on (none turned on yet) and their power


while (length(NotAllowed)==0 || min(NotAllowed)==0)    
    clear MacroVertex % MacroVertex{i}{j} is the set of links that interfer with link i at bit rate j
    GRWeights=[];
    clear GRNeighbors
    clear Ind
    GRLink = [];
    GRBR = [];
    GRPow = [];
    k=1;
    % make a vertex for each link and for each bit-rate/power 
    for i=1:size(Links,1)
        for j=1:length(BitRates{i})
            GRWeights = [GRWeights;Mu(i)*BitRates{i}(j)];
            GRLink = [GRLink;i];
            GRBR = [GRBR;BitRates{i}(j)];
            GRPow = [GRPow; Powers{i}(j)];
            GRNeighbors{k}=[];
            MaxInt(k) = max(H(i,i)*Powers{i}(j)/(exp(BitRates{i}(j)/VScale)-1) - NOISE, 1e-20); % for this bit-rate/power, the interfernce must be less than this
            k=k+1;
        end
    end
    if (length(NotAllowed)==0)
        NotAllowed = zeros(length(GRNeighbors),1);
    end
    for k=1:length(GRLink)
        GRNeighbors{k} = find(GRLink==GRLink(k))';
        GRNeighbors{k} = GRNeighbors{k}(find(GRNeighbors{k}~=k));
        for i=1:length(GRLink)
            if (i~=k && GRLink(i)~=GRLink(k))
                if (length(Set)>0)
                    if (H(GRLink(i),GRLink(k))*GRPow(k) + sum(H(GRLink(Set),GRLink(k)).*GRPow(Set)) >= MaxInt(k))
                        GRNeighbors{k} = [ GRNeighbors{k}, i];
                    end
                else
                    if (H(GRLink(i),GRLink(k))*GRPow(k)  >= MaxInt(k))
                        GRNeighbors{k} = [ GRNeighbors{k}, i];
                    end
                end                
            end
        end
    end
     
    % make graph bidirectional    
    for k = 1:length(GRNeighbors)
        for i=1:length(GRNeighbors{k})
            if (max(GRNeighbors{GRNeighbors{k}(i)} == k)==0)
                GRNeighbors{GRNeighbors{k}(i)} = [GRNeighbors{GRNeighbors{k}(i)},k];
            end
        end
    end
    for k=1:length(GRNeighbors)
        GRNeighbors{k} = sort(unique(GRNeighbors{k}));
        GRNeighbors{k} = GRNeighbors{k}(find(GRNeighbors{k}~=k));
    end
    
    % set weights
    GRWD = zeros(length(GRNeighbors),1);
    for k=1:length(GRNeighbors)
        if (GRWeights(k)~=0)
            J = ismember(GRNeighbors{k}, find(NotAllowed==0));        
            GRWD(k) = sum(GRWeights(GRNeighbors{k}(J)))/GRWeights(k);
        else
            GRWD(k) = inf;
        end
    end
    JJ = find(NotAllowed==0);
    if (min(GRWD(JJ))==inf)
        break;
    end
    I = JJ(find(GRWD(JJ)==min(GRWD(JJ))));
    I=I(1);
    Set = [Set,I];
    NotAllowed(I)=1;
    NotAllowed(GRNeighbors{I})=1;
end

ss = zeros(1,size(V,2));
ss(GRLink(Set))=GRPow(Set);
vv = MakeS(ss,H,VScale);
ContPowVal = vv*Mu;
if (vv*Mu > max(V*Mu))
    disp('found a new assignment');
    ContPowVal = vv*Mu;
    ContPowS = ss;
    ContPowV = vv;
else
    disp('new assignment was no better than the old ones')
    ContPowS = 0;
    ContPowV = 0;
end








