
if (exist('ISet','var')==0 || size(ISet,2)~=size(S,2))
    ISet = zeros(size(S,2),size(S,2));
    for i = 1:size(S,2)
        ISet(i,:) = [ones(1,i-1),0,ones(1,size(S,2)-i)];
    end
    ISet = logical(ISet);
end


% maximize with respect to link K

% compute the derivative at P(K)=0

gg = H(K,K)*Mu(K)/(sum(H(ISet(K,:),K).*P(ISet(K,:)))+NOISE);
for k=1:size(S,2)
    if (k==K)
        continue;
    else
        h = 0;        
        for j=1:size(S,2)
            if (j~=K && j~=k)
                h = h + H(j,k)*P(j);
            end
        end                
        gg = gg - Mu(k)*H(k,k)*P(k)/((h+NOISE)*(h+NOISE+H(k,k)*P(K)));
    end
end
if (0&&gg<0)
    % the derviative at 0 is negative, so the max is at 0 or 1
    P(K) = 0;
    val0 = 0;
    for k = 1:size(S,2)
        if (P(k)~=0)
            val0 = val0 + Mu(k)*log2( 1 + H(k,k)*P(k)/(sum(H(ISet(k,:),k).*P(ISet(k,:))) + NOISE) );
        end
    end
    P(K)=1;
    val1 = 0;
    for k = 1:size(S,2)
        if (P(k)~=0)
            val1 = val1 + Mu(k)*log2( 1 + H(k,k)*P(k)/(sum(H(ISet(k,:),k).*P(ISet(k,:))) + NOISE) );
        end
    end
    if (val0>val1)
        P(K)=0;
    else
        P(k)=1;
    end
else
    % simple interval search
    % newtons method would work as well, and would be much faster!
    
    PL=0;
    PH=1;
    while (PH-PL>1e-6)
        P(K) = (PL*.75+PH*.25);
        valL=0;
        for k = 1:size(S,2)
            if (P(k)~=0)
                valL = valL + Mu(k)*log2( 1 + H(k,k)*P(k)/(sum(H(ISet(k,:),k).*P(ISet(k,:))) + NOISE) );
            end
        end
        P(K) = (PL*.25+PH*.75);
        valH=0;
        for k = 1:size(S,2)
            if (P(k)~=0)
                valH = valH + Mu(k)*log2( 1 + H(k,k)*P(k)/(sum(H(ISet(k,:),k).*P(ISet(k,:))) + NOISE) );
            end
        end
        if (valL<valH)
            PL = (PL*.75+PH*.25);
        else
            PH = PL*.25 + PH*.75;
        end
    end
    P(K) = (PL+PH)/2;
end
        
        
  
    
  
    
    
        
    
    
    