if (exist('CCSG','var')==0)
    CCSG=0;
end



MaxAcc = 1e-3;
[G, VL,x,VM,F] = MakeSubgradient(Mu,V,Paths,FlowUsage, MaxAcc);
ScaleG = 1;
[b,ScaleG]=CheckIfDecDir(Mu,G,V,Paths,FlowUsage);
if (min(VL*G)<0 || b==0)
    MaxAcc = 1e-8;
    [G, VL,x,VM,F] = MakeSubgradient(Mu,V,Paths,FlowUsage, MaxAcc);
    ScaleG = 1;
    [b,ScaleG]=CheckIfDecDir(Mu,G,V,Paths,FlowUsage);
end

    
while ( min(VL*G)<0 && b==1)
    % grad say G is not a direction of descent, but it actually is. Most
    % likely MaxAcc is too large and the subgrad search failed, but this
    % resulted in a suitable G. Since it seems to be a resonable direction,
    % use it... but this is a rare situation
    Mu = SubGradLineSearch(G,Mu,V,Paths, FlowUsage);
    MaxAcc = 1e-3;
    [G, VL,x,VM,F] = MakeSubgradient(Mu,V,Paths,FlowUsage, MaxAcc);
    ScaleG = 1;
    [b,ScaleG]=CheckIfDecDir(Mu,G,V,Paths,FlowUsage);
end

            
    
if ( min(VL*G)>0 && b==0)
    % the grad implies G is a direction of decent, but it is not
    % this could be from G being projected so that Mu>=0. This should not be a problem since the direction are selected so that no project is nessecary
    % however, it may occur due to quad-programming roundoff
   
    
    % this could occur when the direction in VL are not correct
    % e.g., if an active direction is missing, then it must be added. However, since we always use the VMu that are largest, this should not be a problem

    
    MaxAcc = 1e-8; % note that a small MaxAcc can lead to taking small steps unless the line search is very accurate.
    [G, VL,x,VM,F] = MakeSubgradient(Mu,V,Paths,FlowUsage, MaxAcc);
    ScaleG = 1;
    if (min(VL*G)>0)
        [b,ScaleG]=CheckIfDecDir(Mu,G,V,Paths,FlowUsage);
        if (b==0)
            % check if one element of mu is nearly zero
            if (min(Mu(find(Mu>0)))<1e-12*max(Mu))
                % make some elements exactly zero
                I = find(Mu>0);
                I = I(find(Mu(I)<1e-12*max(Mu)));
                Mu(I)=0;
                CarefulSubGrad
            else
                % for sure not decreasing
                % so the subgrad is not correct, most likely it needs to be expanded to include the direction of increase
                cx=0;
                while ( b == 0 )
                    VMu = V*Mu;
                    NumMaxs = length(find(VMu >= max(VMu) - MaxAcc*max(VMu)));
                    if (NumMaxs == size(V,1))
                        disp('cannot find a dec direction: NumMaxs cannot be any larger');
                        % perhaps the best thing to do is to take a non-decreasing step
                        [G, VL,x,VM,F] = MakeSubgradient(Mu,V,Paths,FlowUsage, 1e-6);
                        Mu = Mu + 1e-8*G;
                        Mu(find(Mu<0))=0;
                        CCSG = CCSG + 1;
                        if (CCSG>10)
                            % give up
                            disp('Cannot find a direction of decent. giving up')
                            SchSuc=-1;
                            break
                        else
                            CarefulSubGrad % try again
                        end
                    else
                        h = MaxAcc;
                        while (length(find(VMu >= max(VMu) - h*max(VMu))) == NumMaxs)
                            h = h * 2;
                        end
                        L=0;
                        while (length(find(VMu >= max(VMu) - h*max(VMu))) - NumMaxs>1 && (h-L)>1e-12)
                            if (length(find(VMu >= max(VMu) - (h+L)/2*max(VMu))) == NumMaxs)
                                L = (h+L)/2;
                            else
                                h = (h+L)/2;
                            end
                        end
                        MaxAcc = h;
                        [G, VL,x,VM,F] = MakeSubgradient(Mu,V,Paths,FlowUsage, MaxAcc);
                        if (min(VL*G)<0)
                            % grad search failed
                            % assuming the grad search is good, then this can only occur when minimum has been found
                            break
                        end
                        [b,ScaleG] = CheckIfDecDir(Mu,G,V,Paths,FlowUsage);
                        cx = cx + 1;
                        if (cx>100)
                            disp('cannot find a dec direction');
                            % perhaps the best thing to do is to take a non-decreasing step
                            [G, VL,x,VM,F] = MakeSubgradient(Mu,V,Paths,FlowUsage, 1e-6);
                            Mu = Mu + 1e-8*G;
                            Mu(find(Mu<0))=0;
                            CCSG = CCSG + 1;
                            if (CCSG>10)
                                % give up
                                disp('Cannot find a direction of decent. giving up')
                                SchSuc=-1;
                                break
                            else
                                CarefulSubGrad % try again
                            end
                        end
                    end
                    % either G is a direction of descent or Mu is at the min
                end
            end
        end
    end
end

if (min(VL*G)<0)
    % hopefully Mu is at min, we check that here
    SchDisplay=0;
    MakeRealSch
    if (SchSuc==1)
        % Mu is at the min
    else
        % this is not so good, 
        % maybe the schedule is ok,
        if (abs(sum(xx)-1)<=0.01 && abs(sum(log(FR2))-sum(log(FR)))/abs(sum(log(FR)))<.01 )
            disp('maybe good enough');
            SchSuc=1; % well, good enough
        else
            % there must be a problem with the subgrad search
            % if MaxAcc is too large, then VL is too large, and so there is not direction of descent       
            
            
            % perhaps the best thing to do is to take a non-decreasing step
            [G, VL,x,VM,F] = MakeSubgradient(Mu,V,Paths,FlowUsage, 1e-6);
            Mu = Mu + 1e-8*G;
            Mu(find(Mu<0))=0;
            CCSG = CCSG + 1;
            if (CCSG>10)
                % give up
                disp('Cannot find a direction of decent. giving up')
                SchSuc=-1;
            else
                CarefulSubGrad
            end
        end
    end
end

CCSG = 0;