

Q = VV*VV';
Name  = 'lp Simplex';     % Problem name, not required.
c     = ones(1,size(Q,1));   % Coefficients in linear objective function
A     = Q;   % Matrix defining linear constraints
b_U   = inf * ones(1,size(Q,1));  % Upper bounds on the linear inequalities
x_L   = zeros(1,size(Q,1));  % Lower bounds on x

% x_min and x_max are only needed if doing plots
% x_min = [ 0  0 ]';
% x_max = [10 10 ]';

% b_L, x_U and x_0 have default values and need not be defined.
% It is possible to call lpAssign with empty [] arguments instead
b_L   = ones(1,size(Q,1));
x_U   = [];
x_0   = [];

% Assign routine for defining an LP problem. This allows the user
% to try any solver, including general nonlinear solvers.
Prob = lpAssign(c, A, b_L, b_U, x_L, x_U, x_0, Name,...
                  [], [], [], [], [], [], []);

% Calling driver routine tomRun to run the solver.
% The 1 sets the print level after optimization.

% Result.x_k contains the optimal decision variables.
% Result.f_k is the optimal value.

Result = tomRun('lpSimplex', Prob, 1);
