
clear all
disp('Which sample program to run: \n')
n = input('Press 1 to select an example of finding the optimal scehdule from a set of assignments\npress 2 to select an example that finds the optimal set of assignments and the optimal schedule from these assignments\n');

eval('cd .\OptWoPC');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% OPTIMAL SCHEDULE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if (n==1)
    AllUtil=[];
    % build topology
    NumLinks = [18:22]; %pwang: # of links in the network
    nnn=1     % run the topology with 14 links
    NumIterSinceLastRR = 0;
    ccnntt=0;
    MakeBasicRtSB
    
    % make a good (but most likely not optimal) set of assignments
    while (size(S,1)<sz+10) % add 5 random assigments
        p = randperm(size(Links,1));
        r=zeros(1,size(Links,1));
        for j=1:size(Links,1)
            I = find( H(p(j),find(r==1))>100 | H(find(r==1),p(j))'>100);
            if (isempty(I)==1)
                % neighbor links are not on
                if (rand(1)<.5)
                    r(p(j))=1;
                end
            end
        end
        fd=0;
        for j=1:size(S,1)
            if (norm(S(j,:)-r)==0)
                fd=1;
                break;
            end
        end
        if (fd==0)
            S=[S;r];
        end
    end   
    
    % make schedule from assignments  
        SGDilation
        AllUtil = [AllUtil;sum(log(FR))];

        VMu = V*Mu;
        I = find(VMu >=max(VMu)-1e-2*max(VMu));
        NumIterSinceLastRR = NumIterSinceLastRR +1;
        if (length(I)>size(V,2) || NumIterSinceLastRR>10)
            disp('there are more active assignments than the number of links -  running remove redundancy')
            RedundancyRemoval
            NumIterSinceLastRR = 0;
            if (min(I)==0)
                V = V(logical(I),:);
                S = S(logical(I),:);
                SGDilation
            end
        end
    
    % show/print schedule and assignments
    %disp('Schedule')
    finalSch        %xx
    %disp('Assignments')
    finalAssign     %S(I,:)
    %disp('Utility')
    max(AllUtil)
   
    
    
    
    
else
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% OPTIMAL ASSIGNMENTS   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    clear all;
    AllUtil=[];    
    % build topology
    NumLinks = [18:22]; %pwang: # of links in the network
    nnn=1     % run the topology with 14 links
    NumIterSinceLastRR = 0;
    ccnntt=0;
    MakeBasicRtSB

    % while new, preformance improving assignments can be found
        % find schedule
        % look for new, performance improving assignment
        while (1)
        ccnntt = ccnntt + 1;

        tic
        SGDilation
        AllResults{ccnntt}.Mu = Mu;
        AllResults{ccnntt}.V = V;
        AllResults{ccnntt}.S = S;
        AllResults{ccnntt}.U = sum(log(FR));
        AllResults{ccnntt}.lemita = max(V*Mu); %pwang
        FindMinSchTime
        AllResults{ccnntt}.MinSchTime = MinSchTime;
        AllResults{ccnntt}.SGTime = toc;
        AllUtil = [AllUtil;sum(log(FR))];
        figure(2)
        plot(AllUtil)
        getframe;

        VMu = V*Mu;
        I = find(VMu >=max(VMu)-1e-2*max(VMu));
        NumIterSinceLastRR = NumIterSinceLastRR +1;
        if (length(I)>size(V,2) || NumIterSinceLastRR>10)
            disp('there are more active assignments than the number of links -  running remove redundancy')
            RedundancyRemoval
            NumIterSinceLastRR = 0;
            if (min(I)==0)
                V = V(logical(I),:);
                S = S(logical(I),:);
                SGDilation
            end
        end

        tic
        SimpleKako
        KakoVal = sum(VKako*Mu);

        FindRangeOfLinkBitRates
        MakeExtendedContensionGraph2
        SCont1 = SECont;
        VECont1 = VECont;
        Cont1Val = sum(VECont*Mu);

        FindRangeOfLinkBitRatesExtended
        MakeExtendedContensionGraph2
        SCont2 = SECont;
        VECont2 = VECont;
        Cont2Val = sum(VECont2*Mu);

        modifyExitingAssingments2
        modVal = sum(FoundV*Mu);

        if (max([KakoVal,Cont1Val,Cont2Val,modVal]) < max(V*Mu))
            disp('could not find a new assignment')
            break
        end

        AllResults{ccnntt}.kakoVMu_lemita = KakoVal - max(V*Mu); %pwang
        AllResults{ccnntt}.cont1VMu_lemita = Cont1Val - max(V*Mu); %pwang
        AllResults{ccnntt}.modVMu_lemita = modVal - max(V*Mu); %pwang

        if (KakoVal == max([KakoVal,Cont1Val,Cont2Val,modVal]))
            AddType{ccnntt}.type = 'Simple';
            V = [V;VKako];
            S = [S;SKako];
        elseif (Cont1Val == max([KakoVal,Cont1Val,Cont2Val,modVal]))
            AddType{ccnntt}.type = 'SimpleContension';
            V = [V; VECont1];
            S = [S; SCont1];
        elseif (Cont2Val == max([KakoVal,Cont1Val,Cont2Val,modVal]))
            AddType{ccnntt}.type = 'Contension2';
            V = [V; VECont2];
            S = [S; SCont2];
        elseif (modVal == max([KakoVal,Cont1Val,Cont2Val,modVal]))
            AddType{ccnntt}.type = 'ModExisting';
            V = [V;FoundV];
            S = [S; FoundS];
        end
        disp(sprintf('found new assignement, %f versus %f',V(size(V,1),:)*Mu, max(V(1:size(V,1)-1,:)*Mu)))
        AddType{ccnntt}.v = V(size(V,1),:);
        AddType{ccnntt}.s = S(size(S,1),:);
        AddType{ccnntt}.FindNewTime = toc;
    end 
        
    % show/print final result 
    max(AllUtil)
   
    finalI = find(finalSch > 0.0001); 
    finalSch(finalI)
    finalAssign(finalI,:)     
    
end

